#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#define DB_DBM_HSEARCH 1

#ifdef HAVE_GDBM_H
#  include <gdbm.h>
#elif HAVE_DB_H
#  include <db.h>
#elif defined HAVE_DB4_DB_H
#  include <db4/db.h>
#elif defined HAVE_DB3_DB_H
#  include <db3/db.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include "qDecoder.h"
#include "cwb.h"
#include "cwb_db.h"

int main(int argc, char *argv[]) {
  Q_Entry *real;
  char filename[0xff];
  char *dataDirectory, *dataExtension;
  int  flag;

  real = qfDecoder(REALTIME_CONFIG_FILE);
  if(real == NULL) {
    printf("Realtime configuration file(%s) not found.\n", filename);
    exit(1);
  }
  else {
    dataDirectory = qfValue(real, "DataDirectory");
    dataExtension = qfValue(real, "DataExtension");
    if(dataDirectory == NULL) {
      printf("There is no 'DataDirectory' entry in the %s file.\n", REALTIME_CONFIG_FILE);
      exit(1);
    }
    if(dataExtension == NULL) {
      printf("There is no 'DataExtension' entry in the %s file.\n", REALTIME_CONFIG_FILE);
      exit(1);
    }
  }
  if(argc != 2) {
    printf("Usages : createDB DB-NAME\n");
    exit(1);
  }

  if(qStr09AZaz(argv[1]) == 0 ) {
    printf("Only regular expression is allowed for the database name\n");
    exit(1);
  }

  sprintf(filename, "%s/%s.%s", dataDirectory, argv[1], dataExtension);

  flag = DBCreate(filename, 0644);

  chmod(filename, (unsigned short)atoi(qfValue(real, "FilePermission")));

  if(flag == TRUE) printf("DB(%s) created.\n", filename);
  else printf("DB(%s) creation failed\n", filename);

  return 0;
}

