/****************************************************
** CrazyWWWBoard CGI    'CrazyWWWBoard.cgi' v3.0.1 **
**                                                 **
** Programmed by 'Seung-young, Kim'                **
** Last Updated  : 1997-11-11                      **
**                                                 **
** Email : nobreak@cgiserver.net                   **
**                                                 **
**            (c) Nobreak Technologies             **
****************************************************/

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#define DB_DBM_HSEARCH 1

#ifdef HAVE_GDBM_H
#  include <gdbm.h>
#elif HAVE_DB_H
#  include <db.h>
#elif defined HAVE_DB4_DB_H
#  include <db4/db.h>
#elif defined HAVE_DB3_DB_H
#  include <db3/db.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "qDecoder.h"
#include "cwb.h"
#include "cwb_db.h"
#include "cwb_admin.h"
#include "cwb_write.h"
#include "cwb_read.h"
#include "cwb_list.h"
#include "cwb_delete.h"

#define CWB_UPLOAD_MAX	10*1024 /* 10MB */

Q_Entry *getRealtimeConfig(SysConfig *sys, char *filename);
void  getConfig(SysConfig *sys, cDB *db, DBConfig *conf);
void  setCookie(SysConfig *sys);
int   accessLog(char *filename);
void  relocateList(cDB *db);
void  programInfo(SysConfig *sys);

int main(void){
  cDB db;
  SysConfig sys;
  Q_Entry *sysp;
  DBConfig conf;
  clock_t runTime;

  /* Timer  */
  clock();

  /* ger realtime config */
  sysp = getRealtimeConfig(&sys, REALTIME_CONFIG_FILE);

  /* log on */
  qErrorLog(sys.ErrorLog);
  if(accessLog(sys.AccessLog) == -1) qError("Access logging(%s) fail.\n", sys.AccessLog);

  /*  ġ */
  qDecoder();

  /* Set Cookie */
  if((!strcmp(sys.CookieEnable, "true")) && (qValue("pName") != NULL)) setCookie(&sys);

  /* mime header  */
  qContentType("text/html");

  /* get DB config */
  getConfig(&sys, &db, &conf);

  /*  б */
  if(!strcmp(db.mode, "list"))       cwb_list(sysp, &sys, &db, &conf);
  else if(!strcmp(db.mode, "read"))  cwb_read(sysp, &sys, &db, &conf);
  else if(!strcmp(db.mode, "write")) cwb_write(sysp, &sys, &db, &conf);
  else if(!strcmp(db.mode, "reply")) cwb_write(sysp, &sys, &db, &conf);
  else if(!strcmp(db.mode, "modify"))cwb_modify(sysp, &sys, &db, &conf);
  else if(!strcmp(db.mode, "feed"))  cwb_feed(sysp, &sys, &db, &conf);
  else if(!strcmp(db.mode, "writesave")) {
    cwb_writesave(sysp, &sys, &db, &conf);
    relocateList(&db);

  }
  else if(!strcmp(db.mode, "modifysave")) {
    cwb_modifysave(sysp, &sys, &db, &conf);
    relocateList(&db);
  }
  else if(!strcmp(db.mode, "admin")) cwb_admin(sysp, &sys, &db, &conf);
  else if(!strcmp(db.mode, "adminsave")) {
    cwb_adminsave(sysp, &sys, &db, &conf);
    relocateList(&db);
  }
  else if(!strcmp(db.mode, "delete")) {
    cwb_delete(sysp, &sys, &db, &conf);
    relocateList(&db);
  }
  else qError("'Unknown mode '%s'", db.mode);

  /* α׷   */
  programInfo(&sys);

  /* ޸  */
  qFree();
  //qcFree();
  qfFree(sysp);

  /* Running Time */
  runTime = clock();  /* microsec */
  runTime /= 1000;    /* milisec */

  printf("<!-- CPU Time %.2f seconds -->\n", (float)runTime / (float)1000);

  return 0;
}

Q_Entry *getRealtimeConfig(SysConfig *sys, char *filename) {
  Q_Entry *sysp, *incp;

  char *temp;

  sysp = qfDecoder(filename);
  if(sysp == NULL) qError("Realtime configuration file(%s) not found.", filename);

  for (temp = qsValueFirst(sysp, "Include");temp;temp = qfValueNext()) {
    incp = qfDecoder(temp);
    qsMerge(sysp,incp,1);
    qfFree(incp);
    free(temp);
  }

  sys->ProgramName    = qfValue(sysp, "ProgramName");
  sys->ProgramVersion = qfValue(sysp, "ProgramVersion");

  sys->FilePermission      = qfValue(sysp, "FilePermission");
  sys->DirectoryPermission = qfValue(sysp, "DirectoryPermission");

  sys->DataDirectory = qfValue(sysp, "DataDirectory");
  sys->DataExtension = qfValue(sysp, "DataExtension");

  sys->AccessLog = qfValue(sysp, "AccessLog");
  sys->ErrorLog  = qfValue(sysp, "ErrorLog");

  sys->HtmlHead  = qfValue(sysp, "HtmlHead");
  sys->HtmlTail  = qfValue(sysp, "HtmlTail");
  sys->Help      = qfValue(sysp, "Help");

  sys->IconAdmin  = qfValue(sysp, "IconAdmin");
  sys->IconHome   = qfValue(sysp, "IconHome");
  sys->IconBack   = qfValue(sysp, "IconBack");
  sys->IconHelp   = qfValue(sysp, "IconHelp");
  sys->IconList   = qfValue(sysp, "IconList");
  sys->IconReload = qfValue(sysp, "IconReload");
  sys->IconWrite  = qfValue(sysp, "IconWrite");
  sys->IconModify = qfValue(sysp, "IconModify");
  sys->IconReply  = qfValue(sysp, "IconReply");
  sys->IconDelete = qfValue(sysp, "IconDelete");
  sys->IconPrev   = qfValue(sysp, "IconPrev");
  sys->IconNext   = qfValue(sysp, "IconNext");
  sys->IconAttach = qfValue(sysp, "IconAttach");

  sys->IconWidth  = qfValue(sysp, "IconWidth");
  sys->IconHeight = qfValue(sysp, "IconHeight");
  sys->IconOpen   = qfValue(sysp, "IconOpen");
  sys->IconClose  = qfValue(sysp, "IconClose");
  sys->IconTypeDefault = qfValue(sysp, "IconTypeDefault");
  sys->IconTypeUnknown = qfValue(sysp, "IconTypeUnknown");

  sys->CryptSalt = qfValue(sysp, "CryptSalt");

  sys->SendmailDirectory = qfValue(sysp, "SendmailDirectory");
  sys->SendmailFilename  = qfValue(sysp, "SendmailFilename");
  sys->SendmailOptions   = qfValue(sysp, "SendmailOptions");

  sys->MailHead = qfValue(sysp, "MailHead");
  sys->MailTail = qfValue(sysp, "MailTail");

  sys->MailName         = qfValue(sysp, "MailName");
  sys->MailOrganization = qfValue(sysp, "MailOrganization");

  sys->CookieEnable     = qfValue(sysp, "CookieEnable");
  sys->CookieExpireDays = qfValue(sysp, "CookieExpireDays");

  sys->PageLinkNum = qfValue(sysp, "PageLinkNum");

  sys->TextFieldLength = qfValue(sysp, "TextFieldLength");

  sys->ReSubject = qfValue(sysp, "ReSubject");
  sys->ReText = qfValue(sysp, "ReText");
  sys->ReLine = qfValue(sysp, "ReLine");

  sys->PreviewLines = qfValue(sysp, "PreviewLines");

  sys->HiddenAdminLink = qfValue(sysp, "HiddenAdminLink");
  sys->HiddenHelpLink  = qfValue(sysp, "HiddenHelpLink");

  sys->AllowDBhtml = qfValue(sysp, "AllowDBhtml");
  sys->AllowDBmail = qfValue(sysp, "AllowDBmail");
  sys->AllowUpload = qfValue(sysp, "AllowUpload");

  return sysp;
}

int qsMerge(Q_Entry *first, Q_Entry *add, int flag) {
  Q_Entry *entries;

  for(entries = add; entries; entries = entries->next) {
    _EntryAdd(first, entries->name, entries->value, flag);
  }

  return 0;
}

void getConfig(SysConfig *sys, cDB *db, DBConfig *conf){
  char buf[0xFF];
  int error = FALSE;

  /* db */
  if((db->db = qValue("db")) == NULL) qError("You must specify the database name.");
  if(!strcmp(db->db , "")) qError("You must specify the database name.");
  if(qStr09AZaz(db->db) == 0) qError("The operation is canceled.<br>Only regular expression is allowed for the database name(%s).", db->db);
  /* mode */
  if((db->mode = qValue("mode")) == NULL) db->mode = "list";
  /* page */
  if((db->page = qiValue("page")) == 0) db->page = 1;
  /* num */
  db->num = qiValue("num");

  /* ftype */
  db->ftype = qiValue("ftype");

  /* ftype ϴ  list ⿡ Ѵ,  ftype  Ѵ */
  if(qValue("fname")    != NULL) db->ftype |= (int)FNAME;
  if(qValue("fsubject") != NULL) db->ftype |= (int)FSUBJECT;
  if(qValue("ftext")    != NULL) db->ftype |= (int)FTEXT;

  /* fval */
  if((db->fval = qValue("fval")) == NULL) db->fval = "";
  else qRemoveSpace(db->fval);

  /* fencval */
  db->fencval = qURLencode(db->fval);

  /* default search */
  if(db->ftype == 0 || !strcmp(db->fval, "")) {
    db->ftype = (int)(FSUBJECT | FTEXT);
    db->fval  = "";
  }

  /* password */
  db->password = qValue("password");

  /* backdepth */
  db->backdepth = qiValue("backdepth");

  
  /* conf */
  sprintf(buf, "%s/%s.%s", sys->DataDirectory, db->db, sys->DataExtension);
  DBOpen(buf, CWDB_READ);

  conf->Password = DBFetch("conf.Password");
  conf->Message  = DBFetch("conf.Message");

  conf->HomeUrl    = DBFetch("conf.HomeUrl");
  conf->HomeTarget = DBFetch("conf.HomeTarget");
  conf->BackUrl    = DBFetch("conf.BackUrl");
  conf->BackTarget = DBFetch("conf.BackTarget");

  conf->AdminName    = DBFetch("conf.AdminName");
  conf->AdminEmail   = DBFetch("conf.AdminEmail");
  conf->MailToAdmin  = DBFetch("conf.MailToAdmin");
  conf->MailToSender = DBFetch("conf.MailToSender");

  conf->ListOrder       = DBFetch("conf.ListOrder");
  conf->NameFirst       = DBFetch("conf.NameFirst");
  conf->ArticleNumber   = DBFetch("conf.ArticleNumber");
  conf->VirtualNumber   = DBFetch("conf.VirtualNumber");
  conf->FolderIcon      = DBFetch("conf.FolderIcon");
  conf->AdminCheckbox   = DBFetch("conf.AdminCheckbox");
  conf->UploadEnable    = DBFetch("conf.UploadEnable");
  conf->TypeIcon        = DBFetch("conf.TypeIcon");
  conf->LinkTarget      = DBFetch("conf.LinkTarget");
  conf->Language        = DBFetch("conf.Language");
  conf->WriteMode       = DBFetch("conf.WriteMode");
  conf->HtmlAccept      = DBFetch("conf.HtmlAccept");
  conf->HideSearch      = DBFetch("conf.HideSearch");
  conf->ArticlesPerPage = DBiFetch("conf.ArticlesPerPage");

  conf->UseSysDefHtml = DBFetch("conf.UseSysDefHtml");
  conf->HtmlHead      = DBFetch("conf.HtmlHead");
  conf->HtmlTail      = DBFetch("conf.HtmlTail");
  conf->DefaultText   = DBFetch("conf.DefaultText");

  conf->ListBorderSize       = DBFetch("conf.ListBorderSize");
  conf->ListFontSize         = DBFetch("conf.ListFontSize");
  conf->ListTitleFontColor   = DBFetch("conf.ListTitleFontColor");
  conf->ListTitleBgColor     = DBFetch("conf.ListTitleBgColor");
  conf->ListArticleFontColor = DBFetch("conf.ListArticleFontColor");
  conf->ListArticleBgColor   = DBFetch("conf.ListArticleBgColor");

  conf->ReadTitleBorderSize  = DBFetch("conf.ReadTitleBorderSize");
  conf->ReadTextBorderSize   = DBFetch("conf.ReadTextBorderSize");
  conf->ReadFontSize         = DBFetch("conf.ReadFontSize");
  conf->ReadTitleFontColor   = DBFetch("conf.ReadTitleFontColor");
  conf->ReadTitleBgColor     = DBFetch("conf.ReadTitleBgColor");
  conf->ReadTextFontColor    = DBFetch("conf.ReadTextFontColor");
  conf->ReadTextBgColor      = DBFetch("conf.ReadTextBgColor");
  conf->ReadTextFontType     = DBFetch("conf.ReadTextFontType");

  conf->WriteTitleFontColor  = DBFetch("conf.WriteTitleFontColor");
  conf->WriteTitleBgColor    = DBFetch("conf.WriteTitleBgColor");

  conf->UseSysDefMail = DBFetch("conf.UseSysDefMail");
  conf->MailHead      = DBFetch("conf.MailHead");
  conf->MailTail      = DBFetch("conf.MailTail");
  conf->UploadMaxSize = DBiFetch("conf.UploadMaxSize");
  conf->TableWidth    = DBFetch("conf.TableWidth");
  conf->HrEnable      = DBFetch("conf.HrEnable");

  conf->LastNum  = DBiFetch("conf.LastNum");

  DBClose();

  if(conf->Password == NULL) error = TRUE;
  if(conf->Message  == NULL) conf->Message = "This text will be appeared at top";

  if(conf->HomeUrl    == NULL) conf->HomeUrl = "http://Your HomePage URL";
  if(conf->HomeTarget == NULL) conf->HomeTarget = "";
  if(conf->BackUrl    == NULL) conf->BackUrl = "http://Previous Page URL";
  if(conf->BackTarget == NULL) conf->BackTarget = "";

  if(conf->AdminName    == NULL) conf->AdminName = "Your Name";
  if(conf->AdminEmail   == NULL) conf->AdminEmail = "Your Email Address";
  if(conf->MailToAdmin  == NULL) conf->MailToAdmin = "true";
  if(conf->MailToSender == NULL) conf->MailToSender = "true";

  if(conf->ListOrder       == NULL) conf->ListOrder = "thread";
  if(conf->NameFirst       == NULL) conf->NameFirst = "false";
  if(conf->ArticleNumber   == NULL) conf->ArticleNumber = "true";
  if(conf->VirtualNumber   == NULL) conf->VirtualNumber = "true";
  if(conf->FolderIcon      == NULL) conf->FolderIcon = "true";
  if(conf->AdminCheckbox   == NULL) conf->AdminCheckbox = "false";
  if(conf->UploadEnable    == NULL) conf->UploadEnable = "false";
  if(conf->TypeIcon        == NULL) conf->TypeIcon = "true";
  if(conf->LinkTarget      == NULL) conf->LinkTarget = "_top";
  if(conf->Language        == NULL) conf->Language = "english";
  if(conf->WriteMode       == NULL) conf->WriteMode = "anybody";
  if(conf->HtmlAccept      == NULL) conf->HtmlAccept = "false";
  if(conf->HideSearch      == NULL) conf->HideSearch = "false";
  if(conf->ArticlesPerPage == 0) conf->ArticlesPerPage = 15;

  if(conf->UseSysDefHtml == NULL) conf->UseSysDefHtml = "true";
  /* Do not modify below three lines */
  if(conf->HtmlHead      == NULL) conf->HtmlHead = "";
  if(conf->HtmlTail      == NULL) conf->HtmlTail = "";
  if(conf->DefaultText   == NULL) conf->DefaultText = "";

  if(conf->ListBorderSize       == NULL) conf->ListBorderSize = "0";
  if(conf->ListFontSize         == NULL) conf->ListFontSize = "2";
  if(conf->ListTitleFontColor   == NULL) conf->ListTitleFontColor = "black";
  if(conf->ListTitleBgColor     == NULL) conf->ListTitleBgColor = "#efefef";
  if(conf->ListArticleFontColor == NULL) conf->ListArticleFontColor = "black";
  if(conf->ListArticleBgColor   == NULL) conf->ListArticleBgColor = "#fafafa";

  if(conf->ReadTitleBorderSize  == NULL) conf->ReadTitleBorderSize = "0";
  if(conf->ReadTextBorderSize   == NULL) conf->ReadTextBorderSize = "0";
  if(conf->ReadFontSize         == NULL) conf->ReadFontSize = "2";
  if(conf->ReadTitleFontColor   == NULL) conf->ReadTitleFontColor = "black";
  if(conf->ReadTitleBgColor     == NULL) conf->ReadTitleBgColor = "#efefef";
  if(conf->ReadTextFontColor    == NULL) conf->ReadTextFontColor = "black";
  if(conf->ReadTextBgColor      == NULL) conf->ReadTextBgColor = "#fafafa";
  if(conf->ReadTextFontType     == NULL) conf->ReadTextFontType = "Sans-serif";

  if(conf->WriteTitleFontColor  == NULL) conf->WriteTitleFontColor = "black";
  if(conf->WriteTitleBgColor    == NULL) conf->WriteTitleBgColor = "#f0f0f0";

  if(conf->UseSysDefMail == NULL) conf->UseSysDefMail = "true";
  /* Do not modify below two lines */
  if(conf->MailHead      == NULL) conf->MailHead = "";
  if(conf->MailTail      == NULL) conf->MailTail = "";

  if(conf->UploadMaxSize == 0 || conf->UploadMaxSize >CWB_UPLOAD_MAX) conf->UploadMaxSize = CWB_UPLOAD_MAX / 2;
  if(conf->TableWidth == NULL) conf->TableWidth = "80%";
  if(conf->HrEnable   == NULL) conf->HrEnable = "true";

  if(error == TRUE && strcmp(db->mode, "admin") && strcmp(db->mode, "adminsave")) {
    Q_CGIenv env;
    char server_domain[0xff];

    qCGIenv(&env);
    if(!strcmp(env.server_port, "80")) sprintf(server_domain, "%s", env.server_name);
    else sprintf(server_domain, "%s:%s", env.server_name, env.server_port);

    printf("<head>\n");

    printf("  <meta http-equiv='refresh' content=\"5; url='");
    printf("http://%s%s?db=%s&mode=admin", server_domain, env.script_name, db->db);
    printf("'\">\n");

    printf("  <title>Please, wait a second while refreshing Admin page</title>\n");
    printf("</head>\n");
    printf("<body>\n"
    "<h2><a href=\"http://%s%s?db=%s&mode=admin\">Go to adminstration page</a></h2>\n"
    "</body></html>\n", server_domain, env.script_name, db->db);
    //printf("Welcome to the CrazyWorld.<br>This is your first contact, so you must set some configurations.<br>Click <a href='%s?db=%s&mode=admin'>Admin</a>.", sys->ProgramName, db->db);
    exit(0);
  }
}


/*******************************************
  Ű Ѵ.
    츦 Ѵ.
  1.  ش Ű    : ǳʶ
  2.  ش Ű    : 
  3.  ش Ű ְ   : ı
  4.  ش Ű        : ǳʶ
  5.  ش Ű  ٸ      : 

    ϴ ݽ Ű  
  ߺ Ű   ּȭϱ ̴.

    ν ̸ ּ ش縸 ϰ
  ɼ ְ,   ؼ  ǳʶٹǷ
  Ű  ϸ ٽѹ Է ־ Ѵ.
*******************************************/
void setCookie(SysConfig *sys){
  char *name, *email;

  char *cookie;
  int  set, expdays;

  name   = qRemoveSpace(qValue("pName"));
  email  = qRemoveSpace(qValue("pEmail"));

  /* ̸  */
  if(name  != NULL) {
    set = FALSE;

    cookie  = qCookieValue("NAME");
    expdays = atoi(sys->CookieExpireDays);

    if(cookie == NULL) {
      /*  Ű , ̸ Ǿ */
      if(strcmp(name, "") != 0) set = TRUE;
    }
    else {  /*   Ű Ѵ */
      /* ̸ ̸  Ű  */
      if(strcmp(name,     "") == 0) set = TRUE, expdays = -1;
      /*  Ű ٸ ̸ Ǿ ٲ۴ */
      if(strcmp(name, cookie) != 0) set = TRUE;
    }

    if(set == TRUE) qCookieSet("NAME", name, expdays, NULL, NULL, NULL);
  }

  /* ڿ  */
  if(email  != NULL) {
    set = FALSE;

    cookie  = qCookieValue("EMAIL");
    expdays = atoi(sys->CookieExpireDays);

    if(cookie == NULL) {
      /*  Ű , ̸ Ǿ */
      if(strcmp(email, "") != 0) set = TRUE;
    }
    else {  /*   Ű Ѵ */
      /* ̸ ̸  Ű  */
      if(strcmp(email,     "") == 0) set = TRUE, expdays = -1;
      /*  Ű ٸ ̸ Ǿ ٲ۴ */
      if(strcmp(email, cookie) != 0) set = TRUE;
    }

    if(set == TRUE) qCookieSet("EMAIL", email, expdays, NULL, NULL, NULL);
  }

}

int accessLog(char *filename) {
  FILE *fp;
  char *http_user_agent, *remote_host, *db, *mode, *num;
  struct tm *time;

  time = qGetTime();
  if((http_user_agent = getenv("HTTP_USER_AGENT")) == NULL) http_user_agent = "null";
  if((remote_host     = getenv("REMOTE_HOST"))     == NULL) remote_host     = "null";
  if((db              = qValue("db"))              == NULL) db              = "";
  if((mode            = qValue("mode"))            == NULL) mode            = "list";
  if((num             = qValue("num"))             == NULL) num             = "";

  if((fp = fopen(filename, "at")) == NULL) return -1;
  fprintf(fp, "%04d/%02d/%02d(%02d:%02d) : db=%-10s mode=%-10s num=%-5s from %s(%s)\n", time->tm_year, time->tm_mon, time->tm_mday, time->tm_hour, time->tm_min, db, mode, num, remote_host, http_user_agent);
  fclose(fp);

  return 1;
}

void headHtml(SysConfig *sys, DBConfig *conf) {
  if(!strcmp(conf->UseSysDefHtml, "true") || !strcmp(sys->AllowDBhtml, "false")) {
    qCatFile(sys->HtmlHead);

    /* DB Message */
    printf("\n<!-- Caption -->\n");
    printf("<table border=0 width=%s><tr><th>\n", conf->TableWidth);
    printf("  <font size=3 face='Sans-serif'>%s</font>\n", conf->Message);
    printf("</th></tr></table>\n");
  }
  else {
    printf("%s\n", conf->HtmlHead);
  }

  printf("\n<!-- Main Start-->\n");
}

void tailHtml(SysConfig *sys, DBConfig *conf) {
  printf("\n<!-- Main End-->\n");

  if(!strcmp(conf->UseSysDefHtml, "true") || !strcmp(sys->AllowDBhtml, "false")) {
    qCatFile(sys->HtmlTail);
  }
  else {
    printf("%s\n", conf->HtmlTail);
  }
}

/******************************************************************************
   ٷ  ⸦  ʰ,  Ʒ  ø Ű ص
   ʴ ڴ  б ٶ.

   ̷ ⱳ θ  ũ Ʈ ͽ÷ξ 4.0  ȣȯ
   ̴.
    Խ  ϰ   , ޽  Ϻ
   ȭ ƿ, Ϻ ȭ鿡  дٰ ǥõ back  Ŭϸ
     Ѿ ȭ ŭ javascript:history.go(-n) Ͽ Ϻ ȭ
   ƿ Ǿִ. ̴ Ϻ ȭ ƿȿ ־, ٽ CGI ȣϴ
    ̰ ̴.

   ׷, ͽ÷ξ ޽   ȭ Form  
   Ǵϰ ڰ Խù  ۾    BACK ư
   丮  Ϸϸ ɽõ   ʰ Ǿٴ ޽
   .

   ׸Ͽ, ޽   Ʒ Լ ̿Ͽ, CGI ٽ ѹ
   ȣν Ϻ ȭ form    νĽŰ
   ̴. Locate    ɼ ,   ̰
   ذ ʱ⿡ ø Ѵ.

   ͽ÷ξ form ĳø Ű° Ϲ url encoding Ÿ
   form ش ʰ, multipart/form-data Ÿ ۿ شѴ.
   ̴    ߻ϴµϴ.
   multipart/form-data   ϱ , ӽϿ  
    װ ϰ ӽ ϴµ, ڰ ٽ   䱸ϸ
   ͽ÷ξ ӽ  Ǿµ   ٽÿ䱸ϴ,  
    Ҿٰ ׷ ޽ µ ϴ.

   ׷  Լ     ȿ  ִ.
   Խù ۼ, Ϻȭ µ, ڰ ȭ ٽþ
    reload ư ٰ . , ܰ 
    ڳĴ ޽ Բ, ߺ Ǵµ, ̹ ϸ
   ̷  ذȴ.
******************************************************************************/
void relocateList(cDB *db) {
  Q_CGIenv env;
  char server_domain[0xff];

  qCGIenv(&env);
  if(!strcmp(env.server_port, "80")) sprintf(server_domain, "%s", env.server_name);
  else sprintf(server_domain, "%s:%s", env.server_name, env.server_port);


  qContentType("text/html");

  printf("<head>\n");

  printf("  <meta http-equiv='refresh' content=\"0; url='");
  printf("http://%s%s?db=%s&mode=list&page=%d&ftype=%d&fval=%s", server_domain, env.script_name, db->db, db->page, db->ftype, db->fencval);
  printf("'\">\n");

  printf("  <title>Please, wait a second while refreshing page %d</title>\n", db->page);
  printf("</head>\n");
  exit(0);
}

void programInfo(SysConfig *sys) {
  static int stat = FALSE;

  
  if(stat == TRUE) return;
  stat = TRUE;
  printf("<!-------------------------------------------------------------->\n");
  printf("<!-- CrazyWWWBoard GPL '%17s' Version %-5s      -->\n", sys->ProgramName, sys->ProgramVersion);
  printf("<!--                                                          -->\n");
  printf("<!--             Official site : http://kldp.net/projects/cwb -->\n");
  printf("<!--         Technical contact : http://kldp.net/projects/cwb -->\n");
  printf("<!--                                                          -->\n");
  printf("<!--              Originally programmed by 'Seung-young, Kim' -->\n");
  printf("<!--                                                          -->\n");
  printf("<!--                        1995-2008, CWB Project @ KLDP.net -->\n");
  printf("<!-------------------------------------------------------------->\n");
  printf("\n");
}
