#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#define DB_DBM_HSEARCH 1

#ifdef HAVE_GDBM_H
#  include <gdbm.h>
#elif HAVE_DB_H
#  include <db.h>
#elif defined HAVE_DB4_DB_H
#  include <db4/db.h>
#elif defined HAVE_DB3_DB_H
#  include <db3/db.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "qDecoder.h"
#include "cwb.h"
#include "cwb_db.h"
#include "cwb_admin.h"
#include "cwb_delete.h"

void cwb_delete(Q_Entry *sysp, SysConfig *sys, cDB *db, DBConfig *conf){
  int  pass, i;
  char buf[0xFF], *filename;
  char *temp;
  int num;

  int  newThread;
  
  if(db->num == 0) qError("Handling number must be specified.");

  pass = check_password(sysp, sys, db, conf);
  if(!(pass == PASS_ADMIN || pass == PASS_POSTER)) qError("Only administrator(%s) or Poster can delete.", conf->AdminName);

  sprintf(buf, "%s/%s.%s", sys->DataDirectory, db->db, sys->DataExtension);

  DBOpen(buf, CWDB_REPLACE);

  for (temp = qValueFirst("num");temp;temp = qValueNext()) {
    num = atoi(temp);
    db->num = num;

    if(pass != PASS_ADMIN) {
      pass = check_password(sysp, sys, db, conf);
      if(pass != PASS_POSTER) qError("Only administrator(%s) or Poster can delete.", conf->AdminName);
    }

    /* Խù  Ȯ */
    if(DBFetch("%d.Thread", num) == NULL) qError("Article not found.");

    /* Խù Threadȣ ȹ */
    newThread = DBiFetch("%d.Thread", num);

    /*  Ͽ  ȣ ٽѹ ȮѴ */
    conf->LastNum = DBiFetch("conf.LastNum");   

    /* Խù õȱ Խù Threadȣ ٲ۴ */
    for(i = num + 1; i <= conf->LastNum; i++) {
      if(DBiFetch("%d.Thread", i) == num) {
        sprintf(buf, "%d.Thread", i);
        DBiStore(buf, newThread, CWDB_REPLACE);
      }
    }

    /* ε ϸ ȹ */
    filename = DBFetch("%d.Filename", num);

    /* Խù  */
    DBDelete("%d.Name",    num);
    DBDelete("%d.Email",   num);
    DBDelete("%d.Subject", num);
    DBDelete("%d.Text",    num);

    DBDelete("%d.Filename",   num);
    DBDelete("%d.Filesize", num);

    DBDelete("%d.Date",   num);
    DBDelete("%d.IP",     num);
    DBDelete("%d.Domain", num);

    DBDelete("%d.Lines",  num);
    DBDelete("%d.Access", num);
    DBDelete("%d.Thread", num);

    DBDelete("%d.Password", num);

    /* ε   */
    if(filename != NULL) {
      if(strcmp(filename, "") != 0) {
        sprintf(buf, "%s/%s/%s", sys->DataDirectory, db->db, filename);
        unlink(buf);
      }
    }

  }
  DBClose();
}
